// Generated by ParserBuilder @ 27/05/2001 7:36:02 PM

unit DelphiScanner;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder *)

interface

uses
  Windows, Messages, SysUtils, Classes;

const
  BlkSize = 16384;
  TAB = #09;
  _LF = #10;
  _CR = #13;
  _EF = #0;
  EF = #0;
  _EL = _CR;
  LineEnds: array[0..2] of char = (#13, #10, #0);
  CRLF = #13#10;

type
  TBufBlock = array [0..BlkSize - 1] of char;
  TCocoBuffer = array [0..1024] of ^TBufBlock;
  TStartTable = array [0..255] of integer;
  TGetCH = procedure(pos: longint; Var retCh : Char) of object;
  TCocoErrorProc = procedure(nr, line, col: integer; pos: integer) of object;

type
  TDelphiScanner = class(TObject)
  private
    lastCh,
    ch: char;       (*current input character*)
    curLine: integer;    (*current input line (may be higher than line)*)
    lineStart: longint;    (*start position of current line*)
    apx: longint;    (*length of appendix (CONTEXT phrase)*)
    oldEols: integer;    (*number of _EOLs in a comment*)
    bp, bp0: longint;    (*current position in buf
                           (bp0: position of current token)*)
    LBlkSize: longint;    (*BlkSize*)
    inputLen: longint;    (*source file size*)
    buf: TCocoBuffer;     (*source buffer for low-level access*)
    start: TStartTable; (*start state for every character*)
    CurrentCh: TGetCH;
    {----------------}
    FnextLen: integer;
    Fpos: integer;
    Fcol: integer;
    FnextCol: integer;
    FnextPos: integer;
    Flen: integer;
    FnextLine: integer;
    Fline: integer;
    Fdirectory: string;
    FError: TCocoErrorProc;
    FOutputDirectory: string;
    procedure Err(nr, line, col: integer; pos: longint);
    procedure NextCh;
    function Comment: boolean;
    procedure CapChAt(pos: longint; var retChar : Char);
    procedure DisposeBuf;
  protected
  public
    src: TStringStream;         (*source/list files. To be opened by the main pgm*)
    lst: TStringStream;
    Ferrors: integer;
    constructor Create;
    destructor Destroy; override;
    procedure Get(var sym: integer);
    (* Gets next symbol from source file *)
    procedure GetString(pos: longint; len: integer; var s: string);
    (* Retrieves exact string of max length len from position pos in source file *)
    procedure GetName(pos: longint; len: integer; var s: string);
    (* Retrieves name of symbol of length len at position pos in source file *)
    procedure CharAt(pos: longint; var retChar : Char);
    (* Returns exact character at position pos in source file *)
    procedure _Reset;
    (* Reads and stores source file internally *)
    property Error: TCocoErrorProc read FError write FError;
  published
    { Published declarations }
    property directory: string read Fdirectory write Fdirectory;
    (*of source file*)
    property OutputDirectory: string read FOutputDirectory write FOutputDirectory;
    property line: integer read Fline write Fline;
    (*line and column of current symbol*)
    property col: integer read Fcol write Fcol;
    (*line and column of current symbol*)
    property len: integer read Flen write Flen;      (*length of current symbol*)
    property pos: integer read Fpos write Fpos;
    (*file position of current symbol*)
    property nextLine: integer read FnextLine write FnextLine;
    (*line of lookahead symbol*)
    property nextCol: integer read FnextCol write FnextCol;
    (*column of lookahead symbol*)
    property nextLen: integer read FnextLen write FnextLen;
    (*length of lookahead symbol*)
    property nextPos: integer read FnextPos write FnextPos;
    (*file position of lookahead symbol*)
    property errors: integer read Ferrors write Ferrors;
    (*number of detected errors*)
  end;


implementation



const
  no_Sym = 128; (*error token code*)
  (* not only for errors but also for not finished states of scanner analysis *)
  _EOF = #26; (*MS-DOS _EOF*)

Procedure TDelphiScanner.CapChAt(pos: longint; var retChar : Char);
var
  ch: char;
begin
  if pos >= inputLen then
  begin
    retChar := EF;
    EXIT;
  end;
  ch := upcase(buf[pos div LBlkSize]^[pos mod LBlkSize]);
  if ch <> _EOF then retChar := ch
  else
    retChar := EF
end;

Procedure TDelphiScanner.CharAt(pos: longint; var retChar : Char);
var
  ch: char;
begin
  if pos >= inputLen then
  begin
    retChar := EF;
    EXIT;
  end;
  ch := buf[pos div LBlkSize]^[pos mod LBlkSize];
  if ch <> _EOF then retChar := ch
  else
    retChar := EF
end;

function TDelphiScanner.Comment: boolean;
label
  999;
  VAR
    level: INTEGER;
    oldLineStart,startLine : LONGINT;
  BEGIN
    level := 1; oldLineStart := lineStart;
IF (ch = '{') THEN BEGIN
  
NextCh;
  
WHILE TRUE DO BEGIN
    
IF (ch = '}') THEN BEGIN
      
DEC(level); oldEols := curLine - startLine; NextCh;
      
IF level = 0 THEN BEGIN Comment := TRUE; GOTO 999; END;
    
END ELSE IF ch = EF THEN BEGIN Comment := FALSE; GOTO 999; END
    
ELSE NextCh;
  
END; (* WHILE TRUE *)

END;

IF (ch = '/') THEN BEGIN
  
NextCh;
  
IF (ch = '/') THEN BEGIN
    
NextCh;
    
WHILE TRUE DO BEGIN
      
IF (ch = CHR(13)) THEN BEGIN
        
DEC(level); oldEols := curLine - startLine; NextCh;
        
IF level = 0 THEN BEGIN Comment := TRUE; GOTO 999; END;
      
END ELSE IF ch = EF THEN BEGIN Comment := FALSE; GOTO 999; END
      
ELSE NextCh;
    
END; (* WHILE TRUE *)
  
END ELSE BEGIN
    
IF (ch = _CR) OR (ch = _LF) THEN BEGIN
      
DEC(curLine); lineStart := oldLineStart
    
END;
    
DEC(bp); ch := lastCh;
  
END;

END;

IF (ch = '(') THEN BEGIN
  
NextCh;
  
IF (ch = '*') THEN BEGIN
    
NextCh;
    
WHILE TRUE DO BEGIN
      
IF (ch = '*') THEN BEGIN
        
NextCh;
        
IF (ch = ')') THEN BEGIN
          
DEC(level); NextCh;
          
IF level = 0 THEN BEGIN Comment := TRUE; GOTO 999; END
        
END
      
END ELSE IF ch = EF THEN BEGIN Comment := FALSE; GOTO 999; END
      
ELSE NextCh;
    
END; (* WHILE TRUE *)
  
END ELSE BEGIN
    
IF (ch = _CR) OR (ch = _LF) THEN BEGIN
      
DEC(curLine); lineStart := oldLineStart
    
END;
    
DEC(bp); ch := lastCh;
  
END;

END;

Comment := FALSE;
    999:
end;


procedure TDelphiScanner.Err(nr, line, col, pos: integer);
begin
  INC(Ferrors)
end;

procedure TDelphiScanner.Get(var sym: integer);
var
  state: integer;

  function Equal(s: string): boolean;
  var
    i: integer;
    q: longint;
    cc : Char; // Current Char returned from modifed TGetCh
  begin
    if nextLen <> Length(s) then
    begin
      Equal := False;
      EXIT
    end;
    i := 1;
    q := bp0;
    while i <= nextLen do
    begin
      CurrentCh(q,cc);
      if cc <> s[i] then
      begin
        Equal := False;
        EXIT
      end;
      INC(i);
      INC(q)
    end;
    Equal := True
  end;

  procedure CheckLiteral;
  Var cc : Char;
  begin
    CurrentCh(bp0,cc);
CASE cc OF
    
  'A': IF Equal('ABSOLUTE') THEN BEGIN sym := 57; 
          
 END ELSE IF Equal('ABSTRACT') THEN BEGIN sym := 36; 
          
 END ELSE IF Equal('AND') THEN BEGIN sym := 53; 
          
 END ELSE IF Equal('ANSISTRING') THEN BEGIN sym := 68; 
          
 END ELSE IF Equal('ARRAY') THEN BEGIN sym := 38; 
          
 END;
    
  'B': IF Equal('BOOLEAN') THEN BEGIN sym := 85; 
          
 END ELSE IF Equal('BYTE') THEN BEGIN sym := 81; 
          
 END;
    
  'C': IF Equal('CASE') THEN BEGIN sym := 42; 
          
 END ELSE IF Equal('CDECL') THEN BEGIN sym := 63; 
          
 END ELSE IF Equal('CHAR') THEN BEGIN sym := 86; 
          
 END ELSE IF Equal('CLASS') THEN BEGIN sym := 35; 
          
 END ELSE IF Equal('COMP') THEN BEGIN sym := 96; 
          
 END ELSE IF Equal('CONST') THEN BEGIN sym := 40; 
          
 END ELSE IF Equal('CONSTRUCTOR') THEN BEGIN sym := 46; 
          
 END ELSE IF Equal('CURRENCY') THEN BEGIN sym := 95; 
          
 END;
    
  'D': IF Equal('D1') THEN BEGIN sym := 124; 
          
 END ELSE IF Equal('D2') THEN BEGIN sym := 125; 
          
 END ELSE IF Equal('D3') THEN BEGIN sym := 126; 
          
 END ELSE IF Equal('D4') THEN BEGIN sym := 127; 
          
 END ELSE IF Equal('DEFAULT') THEN BEGIN sym := 28; 
          
 END ELSE IF Equal('DEPRECATED') THEN BEGIN sym := 51; 
          
 END ELSE IF Equal('DESTRUCTOR') THEN BEGIN sym := 47; 
          
 END ELSE IF Equal('DISPID') THEN BEGIN sym := 34; 
          
 END ELSE IF Equal('DISPINTERFACE') THEN BEGIN sym := 13; 
          
 END ELSE IF Equal('DIV') THEN BEGIN sym := 73; 
          
 END ELSE IF Equal('DOUBLE') THEN BEGIN sym := 93; 
          
 END ELSE IF Equal('DYNAMIC') THEN BEGIN sym := 97; 
          
 END;
    
  'E': IF Equal('EKIND') THEN BEGIN sym := 122; 
          
 END ELSE IF Equal('END') THEN BEGIN sym := 14; 
          
 END ELSE IF Equal('EXPORT') THEN BEGIN sym := 99; 
          
 END ELSE IF Equal('EXTENDED') THEN BEGIN sym := 94; 
          
 END ELSE IF Equal('EXTERNAL') THEN BEGIN sym := 100; 
          
 END;
    
  'F': IF Equal('FAR') THEN BEGIN sym := 101; 
          
 END ELSE IF Equal('FILE') THEN BEGIN sym := 44; 
          
 END ELSE IF Equal('FORWARD') THEN BEGIN sym := 102; 
          
 END ELSE IF Equal('FUNCTION') THEN BEGIN sym := 61; 
          
 END;
    
  'G': IF Equal('GUID') THEN BEGIN sym := 120; 
          
 END;
    
  'H': IF Equal('HIGH') THEN BEGIN sym := 116; 
          
 END ELSE IF Equal('HRESULT') THEN BEGIN sym := 89; 
          
 END;
    
  'I': IF Equal('IMPLEMENTATION') THEN BEGIN sym := 113; 
          
 END ELSE IF Equal('IMPLEMENTS') THEN BEGIN sym := 30; 
          
 END ELSE IF Equal('INDEX') THEN BEGIN sym := 23; 
          
 END ELSE IF Equal('INT64') THEN BEGIN sym := 83; 
          
 END ELSE IF Equal('INTEGER') THEN BEGIN sym := 80; 
          
 END ELSE IF Equal('INTERFACE') THEN BEGIN sym := 9; 
          
 END;
    
  'L': IF Equal('LONGINT') THEN BEGIN sym := 82; 
          
 END ELSE IF Equal('LOW') THEN BEGIN sym := 115; 
          
 END;
    
  'M': IF Equal('MESSAGE') THEN BEGIN sym := 103; 
          
 END ELSE IF Equal('MOD') THEN BEGIN sym := 74; 
          
 END;
    
  'N': IF Equal('NODEFAULT') THEN BEGIN sym := 29; 
          
 END ELSE IF Equal('NOT') THEN BEGIN sym := 112; 
          
 END;
    
  'O': IF Equal('OBJECT') THEN BEGIN sym := 49; 
          
 END ELSE IF Equal('OF') THEN BEGIN sym := 39; 
          
 END ELSE IF Equal('OLEVARIANT') THEN BEGIN sym := 66; 
          
 END ELSE IF Equal('OR') THEN BEGIN sym := 52; 
          
 END ELSE IF Equal('ORD') THEN BEGIN sym := 111; 
          
 END ELSE IF Equal('OUT') THEN BEGIN sym := 64; 
          
 END ELSE IF Equal('OVERLOAD') THEN BEGIN sym := 105; 
          
 END ELSE IF Equal('OVERRIDE') THEN BEGIN sym := 104; 
          
 END;
    
  'P': IF Equal('PACKED') THEN BEGIN sym := 37; 
          
 END ELSE IF Equal('PASCAL') THEN BEGIN sym := 106; 
          
 END ELSE IF Equal('PCHAR') THEN BEGIN sym := 88; 
          
 END ELSE IF Equal('PLATFORM') THEN BEGIN sym := 48; 
          
 END ELSE IF Equal('PRIVATE') THEN BEGIN sym := 19; 
          
 END ELSE IF Equal('PROCEDURE') THEN BEGIN sym := 59; 
          
 END ELSE IF Equal('PROPERTY') THEN BEGIN sym := 33; 
          
 END ELSE IF Equal('PROTECTED') THEN BEGIN sym := 20; 
          
 END ELSE IF Equal('PUBLIC') THEN BEGIN sym := 21; 
          
 END ELSE IF Equal('PUBLISHED') THEN BEGIN sym := 22; 
          
 END;
    
  'R': IF Equal('READ') THEN BEGIN sym := 24; 
          
 END ELSE IF Equal('READONLY') THEN BEGIN sym := 109; 
          
 END ELSE IF Equal('REAL') THEN BEGIN sym := 91; 
          
 END ELSE IF Equal('REAL48') THEN BEGIN sym := 90; 
          
 END ELSE IF Equal('RECORD') THEN BEGIN sym := 41; 
          
 END ELSE IF Equal('REGISTER') THEN BEGIN sym := 60; 
          
 END ELSE IF Equal('REINTRODUCE') THEN BEGIN sym := 107; 
          
 END ELSE IF Equal('RESOURCESTRING') THEN BEGIN sym := 117; 
          
 END;
    
  'S': IF Equal('SAFECALL') THEN BEGIN sym := 108; 
          
 END ELSE IF Equal('SET') THEN BEGIN sym := 43; 
          
 END ELSE IF Equal('SHL') THEN BEGIN sym := 75; 
          
 END ELSE IF Equal('SHORTINT') THEN BEGIN sym := 78; 
          
 END ELSE IF Equal('SHR') THEN BEGIN sym := 76; 
          
 END ELSE IF Equal('SINGLE') THEN BEGIN sym := 92; 
          
 END ELSE IF Equal('SIZEOF') THEN BEGIN sym := 77; 
          
 END ELSE IF Equal('SMALLINT') THEN BEGIN sym := 79; 
          
 END ELSE IF Equal('STDCALL') THEN BEGIN sym := 62; 
          
 END ELSE IF Equal('STORED') THEN BEGIN sym := 27; 
          
 END ELSE IF Equal('STRING') THEN BEGIN sym := 67; 
          
 END ELSE IF Equal('SYSTEM') THEN BEGIN sym := 50; 
          
 END;
    
  'T': IF Equal('TYPE') THEN BEGIN sym := 10; 
          
 END;
    
  'U': IF Equal('UGUID') THEN BEGIN sym := 121; 
          
 END ELSE IF Equal('ULPROPID') THEN BEGIN sym := 119; 
          
 END ELSE IF Equal('UNAME') THEN BEGIN sym := 123; 
          
 END ELSE IF Equal('UNIT') THEN BEGIN sym := 7; 
          
 END ELSE IF Equal('USES') THEN BEGIN sym := 114; 
          
 END;
    
  'V': IF Equal('VAR') THEN BEGIN sym := 56; 
          
 END ELSE IF Equal('VARIANT') THEN BEGIN sym := 65; 
          
 END ELSE IF Equal('VIRTUAL') THEN BEGIN sym := 98; 
          
 END;
    
  'W': IF Equal('WIDECHAR') THEN BEGIN sym := 87; 
          
 END ELSE IF Equal('WIDESTRING') THEN BEGIN sym := 69; 
          
 END ELSE IF Equal('WORD') THEN BEGIN sym := 84; 
          
 END ELSE IF Equal('WRITE') THEN BEGIN sym := 26; 
          
 END ELSE IF Equal('WRITEONLY') THEN BEGIN sym := 110; 
          
 END;
    
  'X': IF Equal('XOR') THEN BEGIN sym := 70; 
          
 END;
    
ELSE BEGIN END
    
END
  end;

begin (*Get*)
  WHILE (ch = ' ') OR
        
((ch >= CHR(9)) AND (ch <= CHR(10)) OR
        
(ch = CHR(13))) DO NextCh;
  
IF ((ch = '{') OR (ch = '/') OR (ch = '(')) AND Comment THEN BEGIN Get(sym); EXIT; END;
  pos := nextPos;
  nextPos := bp;
  col := nextCol;
  nextCol := bp - lineStart;
  line := nextLine;
  nextLine := curLine;
  len := nextLen;
  nextLen := 0;
  apx := 0;
  state := start[Ord(ch)];
  bp0 := bp;
  while True do
  begin
    NextCh;
    INC(FnextLen);
    case state of
       1  : IF ((ch >= '0') AND (ch <= '9') OR
             
(ch >= 'A') AND (ch <= 'Z') OR
             
(ch = '_')) THEN BEGIN 
           
END ELSE BEGIN sym := 1; CheckLiteral; EXIT; END;
     
  2  : BEGIN bp := bp - apx - 1; DEC(fnextLen, apx); NextCh; BEGIN sym := 2; EXIT; END; END;
     
  3  : IF ((ch = CHR(0)) OR
             
(ch >= ' ') AND (ch <= '&') OR
             
(ch >= '(')) THEN BEGIN 
           
END ELSE IF (ch = CHR(39)) THEN BEGIN state := 4; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  4  : BEGIN sym := 3; EXIT; END;
     
  5  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN 
           
END ELSE IF (ch = '.') THEN BEGIN state := 6; 
           
END ELSE IF (ch = 'E') THEN BEGIN state := 13; 
           
END ELSE IF (ch = '_') THEN BEGIN state := 17; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  6  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN state := 7; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  7  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN 
           
END ELSE IF (ch = 'E') THEN BEGIN state := 8; 
           
END ELSE IF (ch = '_') THEN BEGIN state := 12; 
           
END ELSE BEGIN sym := 4; EXIT; END;
     
  8  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN state := 10; 
           
END ELSE IF ((ch = '+') OR
                
(ch = '-')) THEN BEGIN state := 9; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  9  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN state := 10; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  10  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN 
           
END ELSE IF (ch = '_') THEN BEGIN state := 11; 
           
END ELSE BEGIN sym := 4; EXIT; END;
     
  11  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN state := 10; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  12  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN state := 7; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  13  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN state := 15; 
           
END ELSE IF ((ch = '+') OR
                
(ch = '-')) THEN BEGIN state := 14; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  14  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN state := 15; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  15  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN 
           
END ELSE IF (ch = '_') THEN BEGIN state := 16; 
           
END ELSE BEGIN sym := 4; EXIT; END;
     
  16  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN state := 15; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  17  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN state := 5; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  18  : IF ((ch >= '0') AND (ch <= '9') OR
             
(ch >= 'A') AND (ch <= 'F')) THEN BEGIN state := 19; 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  19  : IF ((ch >= '0') AND (ch <= '9') OR
             
(ch >= 'A') AND (ch <= 'F')) THEN BEGIN 
           
END ELSE BEGIN sym := 5; EXIT; END;
     
  20  : IF (ch = '.') THEN BEGIN state := 21; INC(apx) 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  21  : BEGIN bp := bp - apx - 1; DEC(fnextLen, apx); NextCh; BEGIN sym := 6; EXIT; END; END;
     
  22  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN 
           
END ELSE IF (ch = '.') THEN BEGIN state := 24; INC(apx) 
           
END ELSE IF (ch = 'E') THEN BEGIN state := 13; 
           
END ELSE IF (ch = '_') THEN BEGIN state := 17; 
           
END ELSE BEGIN sym := 2; EXIT; END;
     
  23  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN state := 25; 
           
END ELSE BEGIN sym := 118; EXIT; END;
     
  24  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN state := 7; apx := 0 
           
END ELSE IF (ch = '.') THEN BEGIN state := 2; INC(apx) 
           
END ELSE BEGIN sym := no_Sym; EXIT; END;
     
  25  : IF ((ch >= '0') AND (ch <= '9')) THEN BEGIN 
           
END ELSE IF (ch = '.') THEN BEGIN state := 20; INC(apx) 
           
END ELSE BEGIN sym := 6; EXIT; END;
     
  26  : BEGIN sym := 8; EXIT; END;
     
  27  : BEGIN sym := 11; EXIT; END;
     
  28  : IF (ch = '.') THEN BEGIN state := 29; 
           
END ELSE BEGIN sym := 25; EXIT; END;
     
  29  : BEGIN sym := 12; EXIT; END;
     
  30  : BEGIN sym := 15; EXIT; END;
     
  31  : BEGIN sym := 16; EXIT; END;
     
  32  : BEGIN sym := 17; EXIT; END;
     
  33  : BEGIN sym := 18; EXIT; END;
     
  34  : BEGIN sym := 31; EXIT; END;
     
  35  : BEGIN sym := 32; EXIT; END;
     
  36  : BEGIN sym := 45; EXIT; END;
     
  37  : BEGIN sym := 54; EXIT; END;
     
  38  : BEGIN sym := 55; EXIT; END;
     
  39  : BEGIN sym := 58; EXIT; END;
     
  40  : BEGIN sym := 71; EXIT; END;
     
  41  : BEGIN sym := 72; EXIT; END;
     
  42  : BEGIN sym := 0; ch := #0; DEC(bp); EXIT END;
      else
      begin
        sym := no_Sym;
        EXIT (*NextCh already done*)
      end;
    end
  end
end;


procedure TDelphiScanner.GetName(pos, len: integer; var s: string);
var
  i: integer;
  p: longint;
  cc : Char;
begin
  if len > 255 then len := 255;
  p := pos;
  i := 1;
  SetLength(S,Len);
  while i <= len do
  begin
    CurrentCh(p,cc);
    s[i] := cc;
    INC(i);
    INC(p)
  end;
end;


procedure TDelphiScanner.GetString(pos, len: integer; var s: string);
var
  i: integer;
  p: longint;
  cc : Char;
begin
  if len > 255 then len := 255;
  p := pos;
  i := 1;
  setLength(S,len);
  while i <= len do
  begin
    CharAt(p,cc);
    s[i] := cc;
    INC(i);
    INC(p)
  end;
end;

procedure TDelphiScanner.NextCh;
  (* Return global variable ch *)
  Var cc : Char;
begin
  lastCh := ch;
  INC(bp);
  CurrentCh(bp,cc);
  ch := cc;
  if (ch = _EL) or (ch = _LF) and (lastCh <> _EL) then
  begin
    INC(curLine);
    lineStart := bp
  end
end;


procedure TDelphiScanner._Reset;
var
  len: longint;
  i, Read: integer;
  AmtTransferred: Integer;
begin (*assert: src has been opened*)
//  len := FileSize(src);
  Len := src.Size;
  DisposeBuf;
  i := 0;
  inputLen := len;
  while len > LBlkSize do
  begin
    NEW(buf[i]);
    Read := BlkSize;
//    BlockRead(src, buf[i]^, Read,AmtTransferred);
    AmtTransferred := src.Read(buf[i]^, Read);
    len := len - AmtTransferred;
    INC(i)
  end;
  NEW(buf[i]);
  Read := len;
  //AmtTransferred :=
  src.Read(buf[i]^, Read);
  buf[i]^[Read] := EF;
  curLine := 1;
  lineStart := -2;
  bp := -1;
  oldEols := 0;
  apx := 0;
  errors := 0;
  NextCh;
end;

constructor TDelphiScanner.Create;
begin
  inherited;
  lst:= TStringStream.Create('');
  src := NIL;
  CurrentCh := CapChAt;
  
start[0   ] := 42  ; start[1   ] := 43  ; start[2   ] := 43  ; start[3   ] := 43  ; 
  
start[4   ] := 43  ; start[5   ] := 43  ; start[6   ] := 43  ; start[7   ] := 43  ; 
  
start[8   ] := 43  ; start[9   ] := 43  ; start[10   ] := 43  ; start[11   ] := 43  ; 
  
start[12   ] := 43  ; start[13   ] := 43  ; start[14   ] := 43  ; start[15   ] := 43  ; 
  
start[16   ] := 43  ; start[17   ] := 43  ; start[18   ] := 43  ; start[19   ] := 43  ; 
  
start[20   ] := 43  ; start[21   ] := 43  ; start[22   ] := 43  ; start[23   ] := 43  ; 
  
start[24   ] := 43  ; start[25   ] := 43  ; start[26   ] := 43  ; start[27   ] := 43  ; 
  
start[28   ] := 43  ; start[29   ] := 43  ; start[30   ] := 43  ; start[31   ] := 43  ; 
  
start[32   ] := 43  ; start[33   ] := 43  ; start[34   ] := 43  ; start[35   ] := 23  ; 
  
start[36   ] := 18  ; start[37   ] := 43  ; start[38   ] := 43  ; start[39   ] := 3  ; 
  
start[40   ] := 32  ; start[41   ] := 33  ; start[42   ] := 40  ; start[43   ] := 37  ; 
  
start[44   ] := 34  ; start[45   ] := 38  ; start[46   ] := 28  ; start[47   ] := 41  ; 
  
start[48   ] := 22  ; start[49   ] := 22  ; start[50   ] := 22  ; start[51   ] := 22  ; 
  
start[52   ] := 22  ; start[53   ] := 22  ; start[54   ] := 22  ; start[55   ] := 22  ; 
  
start[56   ] := 22  ; start[57   ] := 22  ; start[58   ] := 35  ; start[59   ] := 26  ; 
  
start[60   ] := 43  ; start[61   ] := 27  ; start[62   ] := 43  ; start[63   ] := 43  ; 
  
start[64   ] := 39  ; start[65   ] := 1  ; start[66   ] := 1  ; start[67   ] := 1  ; 
  
start[68   ] := 1  ; start[69   ] := 1  ; start[70   ] := 1  ; start[71   ] := 1  ; 
  
start[72   ] := 1  ; start[73   ] := 1  ; start[74   ] := 1  ; start[75   ] := 1  ; 
  
start[76   ] := 1  ; start[77   ] := 1  ; start[78   ] := 1  ; start[79   ] := 1  ; 
  
start[80   ] := 1  ; start[81   ] := 1  ; start[82   ] := 1  ; start[83   ] := 1  ; 
  
start[84   ] := 1  ; start[85   ] := 1  ; start[86   ] := 1  ; start[87   ] := 1  ; 
  
start[88   ] := 1  ; start[89   ] := 1  ; start[90   ] := 1  ; start[91   ] := 30  ; 
  
start[92   ] := 43  ; start[93   ] := 31  ; start[94   ] := 36  ; start[95   ] := 1  ; 
  
start[96   ] := 43  ; start[97   ] := 43  ; start[98   ] := 43  ; start[99   ] := 43  ; 
  
start[100   ] := 43  ; start[101   ] := 43  ; start[102   ] := 43  ; start[103   ] := 43  ; 
  
start[104   ] := 43  ; start[105   ] := 43  ; start[106   ] := 43  ; start[107   ] := 43  ; 
  
start[108   ] := 43  ; start[109   ] := 43  ; start[110   ] := 43  ; start[111   ] := 43  ; 
  
start[112   ] := 43  ; start[113   ] := 43  ; start[114   ] := 43  ; start[115   ] := 43  ; 
  
start[116   ] := 43  ; start[117   ] := 43  ; start[118   ] := 43  ; start[119   ] := 43  ; 
  
start[120   ] := 43  ; start[121   ] := 43  ; start[122   ] := 43  ; start[123   ] := 43  ; 
  
start[124   ] := 43  ; start[125   ] := 43  ; start[126   ] := 43  ; start[127   ] := 43  ; 
  
start[128   ] := 43  ; start[129   ] := 43  ; start[130   ] := 43  ; start[131   ] := 43  ; 
  
start[132   ] := 43  ; start[133   ] := 43  ; start[134   ] := 43  ; start[135   ] := 43  ; 
  
start[136   ] := 43  ; start[137   ] := 43  ; start[138   ] := 43  ; start[139   ] := 43  ; 
  
start[140   ] := 43  ; start[141   ] := 43  ; start[142   ] := 43  ; start[143   ] := 43  ; 
  
start[144   ] := 43  ; start[145   ] := 43  ; start[146   ] := 43  ; start[147   ] := 43  ; 
  
start[148   ] := 43  ; start[149   ] := 43  ; start[150   ] := 43  ; start[151   ] := 43  ; 
  
start[152   ] := 43  ; start[153   ] := 43  ; start[154   ] := 43  ; start[155   ] := 43  ; 
  
start[156   ] := 43  ; start[157   ] := 43  ; start[158   ] := 43  ; start[159   ] := 43  ; 
  
start[160   ] := 43  ; start[161   ] := 43  ; start[162   ] := 43  ; start[163   ] := 43  ; 
  
start[164   ] := 43  ; start[165   ] := 43  ; start[166   ] := 43  ; start[167   ] := 43  ; 
  
start[168   ] := 43  ; start[169   ] := 43  ; start[170   ] := 43  ; start[171   ] := 43  ; 
  
start[172   ] := 43  ; start[173   ] := 43  ; start[174   ] := 43  ; start[175   ] := 43  ; 
  
start[176   ] := 43  ; start[177   ] := 43  ; start[178   ] := 43  ; start[179   ] := 43  ; 
  
start[180   ] := 43  ; start[181   ] := 43  ; start[182   ] := 43  ; start[183   ] := 43  ; 
  
start[184   ] := 43  ; start[185   ] := 43  ; start[186   ] := 43  ; start[187   ] := 43  ; 
  
start[188   ] := 43  ; start[189   ] := 43  ; start[190   ] := 43  ; start[191   ] := 43  ; 
  
start[192   ] := 43  ; start[193   ] := 43  ; start[194   ] := 43  ; start[195   ] := 43  ; 
  
start[196   ] := 43  ; start[197   ] := 43  ; start[198   ] := 43  ; start[199   ] := 43  ; 
  
start[200   ] := 43  ; start[201   ] := 43  ; start[202   ] := 43  ; start[203   ] := 43  ; 
  
start[204   ] := 43  ; start[205   ] := 43  ; start[206   ] := 43  ; start[207   ] := 43  ; 
  
start[208   ] := 43  ; start[209   ] := 43  ; start[210   ] := 43  ; start[211   ] := 43  ; 
  
start[212   ] := 43  ; start[213   ] := 43  ; start[214   ] := 43  ; start[215   ] := 43  ; 
  
start[216   ] := 43  ; start[217   ] := 43  ; start[218   ] := 43  ; start[219   ] := 43  ; 
  
start[220   ] := 43  ; start[221   ] := 43  ; start[222   ] := 43  ; start[223   ] := 43  ; 
  
start[224   ] := 43  ; start[225   ] := 43  ; start[226   ] := 43  ; start[227   ] := 43  ; 
  
start[228   ] := 43  ; start[229   ] := 43  ; start[230   ] := 43  ; start[231   ] := 43  ; 
  
start[232   ] := 43  ; start[233   ] := 43  ; start[234   ] := 43  ; start[235   ] := 43  ; 
  
start[236   ] := 43  ; start[237   ] := 43  ; start[238   ] := 43  ; start[239   ] := 43  ; 
  
start[240   ] := 43  ; start[241   ] := 43  ; start[242   ] := 43  ; start[243   ] := 43  ; 
  
start[244   ] := 43  ; start[245   ] := 43  ; start[246   ] := 43  ; start[247   ] := 43  ; 
  
start[248   ] := 43  ; start[249   ] := 43  ; start[250   ] := 43  ; start[251   ] := 43  ; 
  
start[252   ] := 43  ; start[253   ] := 43  ; start[254   ] := 43  ; start[255   ] := 43  ; 
  Error := Err;
  LBlkSize := BlkSize;
  lastCh := EF;
end;

destructor TDelphiScanner.Destroy;
begin
  if (src <> NIL) then
    src.Free;
  lst.Free;
  DisposeBuf;
  inherited;
end;

procedure TDelphiScanner.DisposeBuf;
var
  idx: integer;
begin
  for idx := 1024 downto 0 do
  begin
    if buf[idx] <> nil then
      Dispose(buf[idx]);
    buf[idx] := nil;
  end;
end;



end. (* DelphiScanner *)
