{-----------------------------------------------------------------------------
 Unit Name: CocoIgnore
 Author:    Administrator
Purpose: Container for GUI-model of ATG File - Holds the IGNORE section that
         specifies what characters to avoid. IGNORE CASE is a property of the
         parent CompilerObj (and it gets written earlier in the ATG than these
         comments.
-----------------------------------------------------------------------------}


unit CocoIgnore;

interface

uses
  Windows, Messages, SysUtils, Classes, pbStrLib;

type
  TCocoIgnore = class(TComponent)
  private
    FIgnoreText: string;
    FComments: string;
    FIgnoreCase: boolean;
    FIsEditing: boolean;
    procedure SetIgnoreText(const Value: string);
    procedure SetComments(const Value: string);
    procedure SetIgnoreCase(const Value: boolean);
    procedure SetIsEditing(const Value: boolean);
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function GetATG: string;
    procedure Clear;
    procedure AddIgnoreText(const it: string);
  published
    { Published declarations }
    property IgnoreCase: boolean read FIgnoreCase write SetIgnoreCase;
    property IgnoreText: string read FIgnoreText write SetIgnoreText;
    property Comments: string read FComments write SetComments;
    property IsEditing: boolean read FIsEditing write SetIsEditing;
  end;

implementation


{ TCocoIgnore }

procedure TCocoIgnore.AddIgnoreText(const it: string);
begin
  fIgnoreText := fIgnoreText + Trim(it);
end;

procedure TCocoIgnore.Clear;
begin
  fIgnoreCase := False;
  fIgnoreText := '';
end;

constructor TCocoIgnore.Create(AOwner: TComponent);
begin
  inherited;
end;

destructor TCocoIgnore.Destroy;
begin
  inherited;
end;

function TCocoIgnore.GetATG: string;
begin
  if not FIsEditing then
  begin
    if (fIgnoreText = '') then
      Result := ''
    else
      Result := Trim(FIgnoreText) + CRLF
  end
  else
    Result := 'IGNORE <!--Modified Text Here-->' + CRLF;
end;

procedure TCocoIgnore.SetComments(const Value: string);
begin
  FComments := Value;
end;

procedure TCocoIgnore.SetIgnoreCase(const Value: boolean);
begin
  FIgnoreCase := Value;
end;

procedure TCocoIgnore.SetIgnoreText(const Value: string);
begin
  if (Trim(Value) <> '') and (pos('IGNORE', UpperCase(Value)) = 0) then
    FIgnoreText := 'IGNORE ' + Value
  else
    FIgnoreText := Value;
end;

procedure TCocoIgnore.SetIsEditing(const Value: boolean);
begin
  FIsEditing := Value;
end;

end.
