{-----------------------------------------------------------------------------
 Unit Name: CocoToken
 Author:    Administrator
Purpose: Container for GUI-model of ATG File - a single Token definition
-----------------------------------------------------------------------------}


unit CocoToken;

interface

uses
  Windows, Messages, SysUtils, Classes,
  pbStrLib, SemActionFormatterComponent;

type
  TCocoToken = class(TComponent)
  private
    FExpression: string;
    FSemanticText: string;
    FSymbol: string;
    procedure SetExpression(const Value: string);
    procedure SetSemanticText(const Value: string);
    procedure SetSymbol(const Value: string);
    function GetSemanticWhiteSpace: string;
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    function GetATG: string;
  published
    { Published declarations }
    property Symbol: string read FSymbol write SetSymbol;
    property Expression: string read FExpression write SetExpression;
    property SemanticText: string read FSemanticText write SetSemanticText;
  end;

implementation

{ TCocoToken }

function TCocoToken.GetATG: string;
begin
  Result := fSymbol + ' = ' + fExpression + '.' + #13#10 + GetSemanticWhiteSpace;
end;

function TCocoToken.GetSemanticWhiteSpace: string;
  //var
  //  Rows: integer;
  //  S, S1, SOC: string;
  //  idx: integer;
  //begin
var 
  S: string;
begin
  if (Trim(FSemanticText) = '') then
    Result := ''
  else
  begin
    if FSemanticText[1] = '.' then system.Delete(FSemanticText, 1, 1);
    ExecuteSemActionFormatterParser('(. ' + FSemanticText + '.)', 15, 0, S);
    Result := S
  end;
end;




//  if (FSemanticText <> '') then
//  begin
//    S := fSemanticText;
//    SOC := StringOfChar(' ', 60);
//    Result := #13#10 + SOC + '(. ';
//    Rows := StrColumns(S, #13#10);
//    for idx := 1 to Rows do
//    begin
//      S1 := StrExtract(S, idx, #13#10);
//      if (idx > 1) and (pos(SOC, S1) = 0) then
//        S1 := #13#10 + SOC + '   ' + S1;
//      if (Trim(S1) <> '') then
//        Result := Result + S1;
//    end;
//    Result := Result + '.)'+#13#10; // #13#10+SOC
//  end
//  else
//    Result := '';
//end;


procedure TCocoToken.SetExpression(const Value: string);
begin
  FExpression := Value;
end;

procedure TCocoToken.SetSemanticText(const Value: string);
begin
  FSemanticText := Value;
end;

procedure TCocoToken.SetSymbol(const Value: string);
begin
  FSymbol := Trim(Value);
end;

end.
